# HOLY - atomic theme

- Holy is a startup theme for your project.
- It respects Brad Frost atomic design: https://bradfrost.com/blog/post/atomic-web-design/

# DRUPAL WAY

- Its based on the Classy theme.
- The goal is to style standard profile installation.

# CREATE CUSTOM THEME

1. Come up with a name of drupal template (YOUR_NAME).

2. Copy folder: themes/contrib/holy -> themes/custom/YOUR_NAME
	> example: themes/custom/kryton

3. Install NPM

	You have to install Node JS (https://nodejs.org) to your computer.

	Go to custom theme folder, where `package.json` is located

	```bash
	> cd themes/custom/YOUR_NAME
	> npm install
	```

4. Rename files

	- themes/custom/YOUR_NAME/YOUR_NAME.theme
	- themes/custom/YOUR_NAME/YOUR_NAME.info.yml
	- themes/custom/YOUR_NAME/YOUR_NAME.libraries.yml
	- config/install/block.block.YOUR_NAME_****.yml

	```bash
	> cd themes/custom/YOUR_NAME
	> gulp rename --name 'YOUR_NAME'
	```

5. Ready for enable your theme.

# GENERATE THEME STYLES

Use gulp to generate and update styles.

```bash
> cd themes/custom/YOUR_NAME
> gulp
```

# GENERATE DOCUMENTATION

Use gulp to generate and update documentation.

```bash
> cd themes/custom/YOUR_NAME/styleguides
> gulp
```

Documentation address:
https://www.YOUR_DOMAIN.com/themes/custom/YOUR_NAME/styleguides/atoms.phtml

example: https://holy.redweb.cz/themes/contrib/holy/styleguides/atoms.phtml

NOTES:
- Running gulp again will update the files and add missing ones.
- For re-work delete folder: **themes/custom/YOUR_NAME/styleguides/code**
- Some files create from: **themes/custom/YOUR_NAME/styleguides/template**

# CODING STANDARDS

STYLELINT
```bash
npx stylelint "css/*.css" --config .stylelintrc-css.json
npx stylelint "sass/**/*.scss" --config .stylelintrc-scss.json
```

PHPCS
```bash
phpcs --standard=Drupal --extensions=php,json,theme,css,scss,md,yml,js .
```
