let gulp = require('gulp'),
    sass = require('gulp-sass')(require('sass')),
    sassGlob = require('gulp-sass-glob'),
    autoprefixer = require('gulp-autoprefixer'),
    csscombx = require('gulp-csscombx'),
    args = require('yargs').argv,
    rimraf = require('gulp-rimraf'),
    rename = require("gulp-rename");

// scss
gulp.task('scss', function () {

  return gulp.src('./sass/components/**/*.scss')
      .pipe(sassGlob())
      .pipe(csscombx())
      .pipe(gulp.dest('./sass/components'));

});

// sass
gulp.task('sass', function () {

  return gulp.src('./sass/*.scss')

      .pipe(sassGlob())
      .pipe(sass())
      .pipe(autoprefixer())
      .pipe(csscombx())
      .pipe(gulp.dest('./css'))

});

// rename (gulp rename --name 'kryton')
gulp.task('rename', function () {

  gulp.src("./YOUR_NAME.theme") 
    .pipe(rimraf())
    .pipe(rename(args.name + '.theme'))
    .pipe(gulp.dest("./"));

  gulp.src("./YOUR_NAME.info.yml")
    .pipe(rimraf())
    .pipe(rename(args.name + '.info.yml'))
    .pipe(gulp.dest("./"));

  gulp.src("./YOUR_NAME.libraries.yml")
    .pipe(rimraf())
    .pipe(rename(args.name + '.libraries.yml'))
    .pipe(gulp.dest("./"));

  return gulp.src('./config/install/*.yml')
    .pipe(rimraf())
    .pipe(rename(function (opt) {
      opt.basename = opt.basename.replace(/YOUR_NAME/, args.name);
      return opt;
    }))
    .pipe(gulp.dest('./config/install'))

});

gulp.task('default', gulp.series('sass', function () {
    gulp.watch( './sass/**/*.scss', gulp.series('sass'));
}));
